#!/bin/sh
#
#  DEFAULT TRINITY STARTUP SCRIPT
#

# This block might not be appropriate for all systems.
# It should work for command line logins but graphical
# login managers might already source these files.
# Multiple sourcing is not a problem when the files are only
# containers for environment variables and such.
if [ -r /etc/xprofile ]; then
  . /etc/xprofile
fi
if [ -r $HOME/.xprofile ]; then
  . $HOME/.xprofile
fi

# Some functions to parse and check path correctly ...
# Usage: is_in_path PATH /usr/bin
is_in_path() {
  var="$1"; search="$2";
  if eval test -z \$$1; then return 1; fi
  ifs="$IFS"; IFS=":"; eval set \$$var; IFS="$ifs"
  for i in $*; do
    [ "${i}" = "${search}" ] && return 0
  done
  return 1
}

# Usage: is_before_in_path ENV_VAR var before_var
# Return 0 if 'var' is before 'before_var' in 'ENV_VAR', 1 otherwise
is_before_in_path() {
  [ $# -ge 3 ] || return 1
  var="$1"; search="$2"; before="$3"
  ifs="$IFS"; IFS=":"; eval set \$$var; IFS="$ifs"
  for i in $*; do
    [ "${i}" = "${search}" ] && return 0
    [ "${i}" = "${before}" ] && return 1
  done
  return 1
}

# Usage: place_before_in_path PATH /opt/trinity/games /usr/games
place_before_in_path() {
  var="$1"; insert="$2";
  if eval test -z \$$1; then
    eval export $var=${insert}
  else
    before="$3"; ifs="$IFS"; IFS=":"; eval set \$$var; IFS="$ifs"
    NPATH=""
    for i in $*; do
      [ "${i}" = "${before}" ] && NPATH="${NPATH}:${insert}"
      NPATH="${NPATH}:${i}"
    done
    eval export $var=${NPATH#:}
  fi
}

# Usage: remove_from_path PATH /opt/trinity/games
remove_from_path() {
  var="$1"; remove="$2";
  if eval test -z \$$1; then return 1; fi
  ifs="$IFS"; IFS=":"; eval set \$$var; IFS="$ifs"
  NPATH=""
  for i in $*; do
    [ "${i}" != "${remove}" ] && NPATH="${NPATH}:${i}"
  done
  eval export $var=${NPATH#:}
}

# Portable alternative to the file operator -nt (among shells)
is_newer() {
  if test -n "$(find $1 -prune -newer $2 -print)"
  then
    return 0
  fi
  return 1
}

echo "[starttde] Starting starttde." 1>&2
echo "[starttde] This script is $0" 1>&2

# Avoid any possible conflict with KDE4. Therefore within this script
# use full path names to all binaries used.

# The binaries for TDE are located in the same place as this script.
# To determine that location use the following method rather than presuming
# the existence of $TDEDIR. That environment variable might not be
# defined or defined to point to KDE4 binaries.
BIN_DIR=""

# Let's check if this script is called from the Debian alternatives
# See: https://wiki.debian.org/DebianAlternatives
if [ "$(readlink -- "$0")" = "/etc/alternatives/x-session-manager" ]
then
  # Check if it is not a dangling symlink
  if [ -L "/etc/alternatives/x-session-manager" ] && \
     [ -e "/etc/alternatives/x-session-manager" ]
  then
    # Determine location by reading the alternative symlink
    BIN_DIR="$(readlink -- "/etc/alternatives/x-session-manager")"
    BIN_DIR="$(dirname -- "$BIN_DIR")"
  fi
fi
# Assign a default value if 'BIN_DIR' is unset or null
BIN_DIR="${BIN_DIR:=$(dirname -- "$0")}"

if [ -x ${BIN_DIR}/tde-config ]; then
  TDE_VERSION="$( ${BIN_DIR}/tde-config --version | sed -n 's|^TDE: ||p' )"
  TDEDIR="${BIN_DIR%/bin}"
  echo "[starttde] TDE version is $TDE_VERSION" 1>&2
  echo "[starttde] TDE base directory is $TDEDIR" 1>&2
else
  echo "[starttde] Unable to determine the TDE bin directory, where this script should be installed."
  echo "[starttde] This script should be installed in the same directory."
  echo "[starttde] Exiting."
  exit 1
fi
unset BIN_DIR TDE_VERSION
export TDEDIR

# When the X server dies we get a HUP signal from xinit. We must ignore it
# because we still need to do some cleanup.
trap 'echo "[starttde] GOT SIGHUP"' HUP

# Check if a TDE session is already running.
if kcheckrunning >/dev/null 2>&1; then
  echo "[starttde] TDE seems to be already running on this display."
  xmessage -center -geometry 500x100 "TDE seems to be already running on this display." > /dev/null 2>/dev/null
  exit 1
fi

# Set the background color.
# The standard X background is nasty, causing moire effects and exploding
# people's heads. We use colours from the standard TDE palette for those with
# palettised displays.
if test -z "$XDM_MANAGED" || echo "$XDM_MANAGED" | grep ",auto" > /dev/null; then
  xsetroot -solid "#618DCC" # sky blue
fi

# Unset this for Darwin since it will screw up TDE's dynamic-loading.
unset DYLD_FORCE_FLAT_NAMESPACE

# Check whether prelinking is enabled. If yes, then exporting TDE_IS_PRELINKED improves
# loading TDE. The $TDE_IS_PRELINKED variable might already be set on some systems
# through /etc/profile.d. Therefore first check whether the variable exists.
if [ "$TDE_IS_PRELINKED" = "" ]; then
  if [ -r /etc/default/prelink ]; then
    . /etc/default/prelink
  elif [ -r /etc/sysconfig/prelink ]; then
    . /etc/sysconfig/prelink
  fi
  if [ "$PRELINKING" = "yes" ]; then
    export TDE_IS_PRELINKED=1
  fi
fi

# Boot sequence:
#
# tdeinit is used to fork off processes which improves memory usage
# and startup time.
#
# * tdeinit starts the dcopserver and tdelauncher first.
# * Then kded is started. kded is responsible for keeping the sycoca
#   database up to date. When an up to date database is present it goes
#   into the background and the startup continues.
# * Then tdeinit starts kcminit. kcminit performs initialisation of
#   certain devices according to the user's settings
#
# * Then ksmserver is started which takes control of the rest of the startup sequence.

# The user's personal TDE directory usually is $HOME/.trinity.
# This setting may be overridden by setting $TDEHOME. When migrating profiles
# must be careful here because $HOME/.kde was used commonly in the pre-KDE4
# days for the user's TDE profile, but now with KDE4 common on systems,
# $HOME/.kde might point to KDE4 profile settings. The existence of KDE4
# does not mean all people are using KDE4.

if [ "$TDEHOME" != "" ]; then
  echo "[starttde] TDEHOME is preset to $TDEHOME." 1>&2
  export TDEHOME=$TDEHOME
else
  # $TDEHOME is NOT already preset in the environment. Try to help.
  # This might be overkill but does provide flexibility.
  # This script and kstandardirs.h and kstandardirs.cpp must match.
  # The latter two must be edited/patched before compiling.
  echo "[starttde] TDEHOME is not set." 1>&2
  # Default value: $HOME/.trinity. Most users will use this.
  export TDEHOME=$HOME/.trinity

  if [ ! -d $HOME/.trinity ] && [ ! -f /usr/bin/kde4-config ] && [ "$TDEDIR" = "/usr" ] && [ -d $HOME/.kde ]; then
    # Looks like Trinity is installed and not playing second fiddle to KDE4.
    export TDEHOME=$HOME/.kde
  fi
  echo "[starttde] Set TDEHOME to $TDEHOME." 1>&2
fi

# tdesu needs something to find root's TDE profile. Set the TDEROOTHOME variable
# here as last resort. /root/.trinity is a safe presumption. If an admin wants
# a different location then set the TDEROOTHOME variable elsewhere.
if [ "$TDEROOTHOME" = "" ]; then
  export TDEROOTHOME=/root/.trinity
  echo "[starttde] Setting TDEROOTHOME to $TDEROOTHOME."
fi

# Modify the following environment variables only as necessary.

  if ! is_in_path PATH "$TDEDIR/games" ; then
    # Respect the traditional path order. Don't blindly place $TDEDIR/games
    # first in the path. Only place $TDEDIR/games before /usr/games. If packagers
    # are adding $TDEDIR/games elsewhere, then they need to ensure the traditional
    # search patch is respected.
    # Is there a way we can check that $TDEDIR/games is always placed only just before
    # /usr/games in the search path?
    if is_in_path PATH "/usr/games"; then
      place_before_in_path PATH "$TDEDIR/games" "/usr/games"
    else
      export PATH=$TDEDIR/games:$PATH
    fi
  fi

  if ! is_in_path PATH "$TDEDIR/bin" ; then
    # Respect the traditional path order. Don't blindly place $TDEDIR/bin
    # first in the path. Only place $TDEDIR/bin before /usr/bin. This order is
    # consistent with tdelibs/tdesu/stub.cpp. If packagers are adding $TDEDIR/bin
    # elsewhere, then they need to ensure the traditional search patch is respected.
    # Is there a way we can check that $TDEDIR/bin is always placed only just before
    # /usr/bin in the search path?
    if is_in_path PATH "/usr/bin"; then
      place_before_in_path PATH "$TDEDIR/bin" "/usr/bin"
    else
      export PATH=$TDEDIR/bin:$PATH
    fi
  fi

  if [ -x /usr/bin/manpath ]; then
    if [ "`manpath 2>/dev/null | grep \"$TDEDIR/share/man\"`" = "" ]; then
      export MANPATH=$TDEDIR/share/man:$MANPATH
    fi
  else
    if [ "`echo $MANPATH | grep \"$TDEDIR/share/man\"`" = "" ]; then
      export MANPATH=$TDEDIR/share/man:$MANPATH
    fi
  fi


if [ "$XDG_CONFIG_DIRS" = "" ]; then
  if [ -d /etc/xdg ]; then
    XDG_CONFIG_DIRS=/etc/xdg
  fi
fi
if [ -d /etc/trinity/xdg ]; then
  TDE_XDG_DIR="/etc/trinity/xdg"
elif [ -d /etc/tde/xdg ]; then
  TDE_XDG_DIR="/etc/tde/xdg"
elif [ -d $TDEDIR/xdg ]; then
  TDE_XDG_DIR="$TDEDIR/xdg"
elif [ -d $TDEDIR/etc/xdg ]; then
  TDE_XDG_DIR="$TDEDIR/etc/xdg"
elif [ -d $TDEDIR/etc/trinity/xdg ]; then
  TDE_XDG_DIR="$TDEDIR/etc/trinity/xdg"
elif [ -d $TDEDIR/etc/tde/xdg ]; then
  TDE_XDG_DIR="$TDEDIR/etc/tde/xdg"
elif [ -d $TDEDIR/trinity/xdg ]; then
  TDE_XDG_DIR="$TDEDIR/trinity/xdg"
elif [ -d $TDEDIR/tde/xdg ]; then
  TDE_XDG_DIR="$TDEDIR/tde/xdg"
fi
if [ -d $TDE_XDG_DIR ]; then
  if [ "`echo $XDG_CONFIG_DIRS | grep \"$TDE_XDG_DIR\"`" = "" ]; then
    if [ "$XDG_CONFIG_DIRS" = "" ]; then
      XDG_CONFIG_DIRS=$TDE_XDG_DIR
    else
      XDG_CONFIG_DIRS=$TDE_XDG_DIR:$XDG_CONFIG_DIRS
    fi
  fi
fi
if [ "$XDG_CONFIG_DIRS" != "" ]; then
  export XDG_CONFIG_DIRS
fi

# Explicitly set $XDG_DATA_DIRS only when Trinity is not installed in /usr.
# Explicitly declaring $XDG_DATA_DIRS will override the default search path of /usr/share.
# Explicitly declaring $XDG_DATA_DIRS will override $TDEDIRS, which must then be
# explicitly identified in the $XDG_DATA_DIRS string to remain useful.
# The $TDEDIR variable is intended to be singular and $TDEDIRS plural. When $TDEDIRS
# exists in the environment then parse that variable into separate directories.
# $TDEDIRS should contain whatever is set in $TDEDIR. Therefore any additional directories
# set in $TDEDIRS are intended to override data files found in $TDEDIR. Those additional
# directories should be placed before $TDEDIR and before /usr/share.
if [ "$TDEDIR" != "/usr" ] && [ -d $TDEDIR/share ]; then
  # If '/usr/share' is not already there, we include it at the last position.
  if ! is_in_path XDG_DATA_DIRS "/usr/share"; then
    if [ "$XDG_DATA_DIRS" = "" ]; then
      XDG_DATA_DIRS=/usr/share    # In case XDG_DATA_DIRS is empty, to avoid a leading :
    else
      XDG_DATA_DIRS=$XDG_DATA_DIRS:/usr/share
    fi
  fi
  # If '/usr/local/share' is not already there, we include it before '/usr/share'
  if ! is_in_path XDG_DATA_DIRS "/usr/local/share"; then
    place_before_in_path XDG_DATA_DIRS "/usr/local/share" "/usr/share"
  fi  

  # Ensure that $TDEDIR/share is always before '/usr/local/share' and '/usr/share'.
  if ! is_in_path XDG_DATA_DIRS "$TDEDIR/share" ||
     is_before_in_path XDG_DATA_DIRS "/usr/local/share" "$TDEDIR/share" ||
     is_before_in_path XDG_DATA_DIRS "/usr/share" "$TDEDIR/share"; then
    remove_from_path XDG_DATA_DIRS "$TDEDIR/share"
    if is_before_in_path XDG_DATA_DIRS "/usr/local/share" "/usr/share"; then
      place_before_in_path XDG_DATA_DIRS "$TDEDIR/share" "/usr/local/share"
    else
      place_before_in_path XDG_DATA_DIRS "$TDEDIR/share" "/usr/share"
    fi
  fi

  # Adds supplementary directories from TDEDIRS, if any, before TDEDIR.
  if [ "$TDEDIRS" != "" ]; then
    ifs="$IFS"; IFS=":"; set $TDEDIRS; IFS="$ifs"
    for dir in $*; do
      if ! is_in_path XDG_DATA_DIRS "$dir/share" && [ -d "$dir/share" ]; then
        XDG_DATA_DIRS=$dir/share:$XDG_DATA_DIRS
      fi
    done
  fi
  export XDG_DATA_DIRS
fi

echo "[starttde] XDG_DATA_DIRS: $XDG_DATA_DIRS" 1>&2

test -n "$TDEHOME" && tdehome=`echo "$TDEHOME" | sed "s,^~/,$HOME/,"`

# Allow interested applications, such as the Plasma control wrapper,
# to know that this is a Trinity desktop and not a KDE one.
export DESKTOP_SESSION=trinity

# Create profile directory.
if [ ! -d "$tdehome" ]; then
  echo "[starttde] Creating $tdehome" 1>&2
  mkdir -m 700 -p "$tdehome"
fi
if [ -d "$tdehome" ]; then
  # Run some R14 updates.
  R14_UPDATED="`$TDEDIR/bin/kreadconfig --file kdeglobals --group "R14 XDG Updates" --key Updated --default false`"
  R14_VERSION="`$TDEDIR/bin/kreadconfig --file kdeglobals --group "R14 XDG Updates" --key Version --default 0`"
  if [ -e $TDEDIR/bin/r14-xdg-update ]; then
    # Script version index is used to allow automatic rerun
    R14_SCRIPT="`sed -n "s/SCRIPT_VERSION=\([0-9]*\)/\1/p" $TDEDIR/bin/r14-xdg-update`"
  else
    R14_SCRIPT=0
  fi
  if [ "$R14_UPDATED" != "true" ] || [ "$R14_VERSION" -lt "$R14_SCRIPT" ]; then
    if [ -e $TDEDIR/bin/r14-xdg-update ]; then
      echo "[starttde] Running $TDEDIR/bin/r14-xdg-update script." 1>&2
      sh $TDEDIR/bin/r14-xdg-update
      EXIT_CODE="$?"
    else
      echo "[starttde] $TDEDIR/bin/r14-xdg-update does not exist." 1>&2
      echo "           Unable to perform a profile update for Trinity release R14."
    fi
    if [ "$EXIT_CODE" != "0" ]; then
      exit 1
    fi
  fi
fi

# Please see tdestartupconfig source for usage.
mkdir -m 700 -p "$tdehome/share"
mkdir -m 700 -p "$tdehome/share/config"
cat >"$tdehome/share/config/startupconfigkeys" <<EOF
kcminputrc Mouse cursorTheme ''
kcminputrc Mouse cursorSize ''
kpersonalizerrc General FirstLogin true
ksplashrc KSplash Theme Default
kcmrandrrc Display ApplyOnStartup false
kcmrandrrc [Screen0]
kcmrandrrc [Screen1]
kcmrandrrc [Screen2]
kcmrandrrc [Screen3]
kcmfonts General forceFontDPI 0
EOF
$TDEDIR/bin/tdestartupconfig
if test $? -ne 0; then
  xmessage -center -geometry 500x100 "Could not start tdestartupconfig. Check your installation."
fi
# $tdehome/share/config/startupconfig should exist but avoid script failure if not.
if [ -r "$tdehome/share/config/startupconfig" ]; then
  . "$tdehome/share/config/startupconfig"
fi

# Make sure a default wallpaper is set.
if [ ! -e "$tdehome/share/config/kdesktoprc" ]; then
 # With Trinity this file should exist, but test first.
  if [ -r $TDEDIR/share/wallpapers/Trinity-lineart.svg.desktop ]; then
cat >"$tdehome/share/config/kdesktoprc" <<EOF
[Desktop0]
Wallpaper=Trinity-lineart.svg
WallpaperMode=Scaled
EOF
  fi
fi

# XCursor mouse theme needs to be applied here to work even for kded or ksmserver.
if test -n "$kcminputrc_mouse_cursortheme" -o -n "$kcminputrc_mouse_cursorsize" ; then
  kapplymousetheme "$kcminputrc_mouse_cursortheme" "$kcminputrc_mouse_cursorsize"
  if test $? -eq 10; then
    export XCURSOR_THEME=default
  elif test -n "$kcminputrc_mouse_cursortheme"; then
    export XCURSOR_THEME="$kcminputrc_mouse_cursortheme"
  fi
  if test -n "$kcminputrc_mouse_cursorsize"; then
    export XCURSOR_SIZE="$kcminputrc_mouse_cursorsize"
  fi
fi

if test "$kcmrandrrc_display_applyonstartup" = "true"; then
  # 4 screens is hopefully enough.
  for scrn in 0 1 2 3; do
    args=
    width="\$kcmrandrrc_screen${scrn}_width" ; eval "width=$width"
    height="\$kcmrandrrc_screen${scrn}_height" ; eval "height=$height"
    if test -n "${width}" -a -n "${height}"; then
      args="$args -s ${width}x${height}"
    fi
    refresh="\$kcmrandrrc_screen${scrn}_refresh" ; eval "refresh=$refresh"
    if test -n "${refresh}"; then
      args="$args -r ${refresh}"
    fi
    rotation="\$kcmrandrrc_screen${scrn}_rotation" ; eval "rotation=$rotation"
    if test -n "${rotation}"; then
      case "${rotation}" in
        0)
          args="$args -o 0"
          ;;
        90)
          args="$args -o 1"
          ;;
        180)
          args="$args -o 2"
          ;;
        270)
          args="$args -o 3"
          ;;
      esac
    fi
    reflectx="\$kcmrandrrc_screen${scrn}_reflectx" ; eval "reflectx=$reflectx"
    if test "${refrectx}" = "true"; then
      args="$args -x"
    fi
    reflecty="\$kcmrandrrc_screen${scrn}_reflecty" ; eval "reflecty=$reflecty"
    if test "${refrecty}" = "true"; then
      args="$args -y"
    fi
    if test -n "$args"; then
      xrandr $args
    fi
  done
fi

dl=$DESKTOP_LOCKED
unset DESKTOP_LOCKED # Don't want it in the environment

# Launch splash that doesn't need any TDE libraries here, before
# TDE libraries are loaded into memory (which may take some time
# with cold caches). Makes the splash appear sooner.
# If kpersonalizer needs to be run splash will be started only later.
if test -z "$dl" && test "$kpersonalizerrc_general_firstlogin" != "true"; then
  case "$ksplashrc_ksplash_theme" in
    Simple)
      ksplashsimple
      ;;
    *)
      ;;
  esac
fi

if test "$kcmfonts_general_forcefontdpi" -eq 120; then
  xrdb -quiet -merge -nocpp <<EOF
Xft.dpi: 120
EOF
elif test "$kcmfonts_general_forcefontdpi" -eq 96; then
  xrdb -quiet -merge -nocpp <<EOF
Xft.dpi: 96
EOF
fi

# Configuration of the gtk_qt_engine if not already set.

if test -n "$TDEDIRS"; then
  tdedirs_first=${TDEDIRS%%:*}
  TGTK_RC_ENGINE=$tdedirs_first/share/kgtk/gtk-qt-engine.rc.sh
  TGTK_RC_TDE1=$tdedirs_first/share/kgtk/.gtkrc-2.0-kde4
  TGTK_RC_TDE2=$tdedirs_first/share/kgtk/.gtkrc-2.0-kde-kde4
else
  TGTK_RC_ENGINE=$TDEDIR/share/kgtk/gtk-qt-engine.rc.sh
  TGTK_RC_TDE1=$TDEDIR/share/kgtk/.gtkrc-2.0-kde4
  TGTK_RC_TDE2=$TDEDIR/share/kgtk/.gtkrc-2.0-kde-kde4
fi

if [ ! -e "$tdehome/env/gtk-qt-engine.rc.sh" ] && [ -e $TGTK_RC_ENGINE ]; then
 mkdir -p "$tdehome/env"
 cp -f $TGTK_RC_ENGINE "$tdehome/env"
 chmod 755 "$tdehome/env/gtk-qt-engine.rc.sh"
fi

if [ ! -e $HOME/.gtkrc-2.0-kde4 ] && [ -e $TGTK_RC_TDE1 ]
then
 cp -f $TGTK_RC_TDE1 $HOME
fi

if [ ! -e $HOME/.gtkrc-2.0-kde-kde4 ] && [ -e $TGTK_RC_TDE2 ]
then
 cp -f $TGTK_RC_TDE2 $HOME
fi

# Source scripts found in <localprefix>/env/*.sh and <prefixes>/env/*.sh
# (where <localprefix> is $TDEHOME or ~/.trinity, and <prefixes> is where TDE is installed)
#
# This is where you can define environment variables that will be available to
# all TDE programs. That is where to run agents using for example, eval `ssh-agent`
# or eval `gpg-agent --daemon`.
# Note: if you do that, you should also put "ssh-agent -k" as a shutdown script.
# (Read the end of this script for running shutdown scripts).
# For anything else (that doesn't set env vars, or that needs a window manager),
# better use the Autostart folder.

exepath=`tde-config --path exe | tr : '\n'`

for prefix in `echo "$exepath" | sed -n -e 's,/bin[^/]*/,/env/,p'`; do
  for file in "$prefix"*.sh; do
    test -r "$file" && . "$file"
  done
done

# Activate the TDE font directories.
#
# There are 4 directories that may be used for supplying fonts for TDE.
#
# There are two system directories. These belong to the administrator.
# There are two user directories, where the user may add her own fonts.
#
# The 'override' versions are for fonts that should come first in the list,
# i.e. if you have a font in your 'override' directory, it will be used in
# preference to any other.
#
# The preference order looks like this:
# user override, system override, X, user, system.
#
# Where X is the original font database that was set up before this
# script runs.

usr_odir=$HOME/.fonts/kde-override
usr_fdir=$HOME/.fonts

# Add any user-installed font directories to the X font path.
tde_fontpaths=$usr_fdir/fontpaths
do_usr_fdir=1
do_usr_odir=1
if test -r "$tde_fontpaths" ; then
  savifs=$IFS
  IFS="
"
  for fpath in `grep -v '^[   ]*#' < "$tde_fontpaths"` ; do
    rfpath=`echo $fpath | sed "s:^~:$HOME:g"`
    if test -s "$rfpath"/fonts.dir; then
      xset fp+ "$rfpath"
      if test "$rfpath" = "$usr_fdir"; then
        do_usr_fdir=0
      fi
      if test "$rfpath" = "$usr_odir"; then
        do_usr_odir=0
      fi
    fi
  done
  IFS=$savifs
fi

echo "[starttde] TDEDIR: $TDEDIR" 1>&2
echo "[starttde] TDEDIRS: $TDEDIRS" 1>&2

if test -n "$TDEDIRS"; then
  tdedirs_first=${TDEDIRS%%:*}
  sys_odir=$tdedirs_first/share/fonts/override
  sys_fdir=$tdedirs_first/share/fonts
else
  sys_odir=$TDEDIR/share/fonts/override
  sys_fdir=$TDEDIR/share/fonts
fi

if test -n "$TDEDIRS"; then
  tdedirs_first=${TDEDIRS%%:*}
  echo "[starttde] tdedirs_first: $tdedirs_first"
  if [ -r $tdedirs_first/share/kgtk/preload ]; then
    echo "[starttde] Reading from $tdedirs_first/share/kgtk/preload"
    read -r TGTK_PRELOAD < $tdedirs_first/share/kgtk/preload
  fi
else
  if [ -r $TDEDIR/share/kgtk/preload ]; then
    read -r TGTK_PRELOAD < $TDEDIR/share/kgtk/preload
  fi
fi

if [ "$TGTK_PRELOAD" != "" ]; then
  if [ -e /usr/lib64/libnspr4.so ]; then
    TGTK_NSPR_PRELOAD="/usr/lib64/libnspr4.so:"
  elif [ -e /usr/lib/libnspr4.so ]; then
    TGTK_NSPR_PRELOAD="/usr/lib/libnspr4.so:"
  fi
  export LD_PRELOAD=$TGTK_PRELOAD:$TGTK_NSPR_PRELOAD$LD_PRELOAD
fi

# We run mkfontdir on the user's font dirs (if we have permission) to pick
# up any new fonts they may have installed. If mkfontdir fails, we still
# add the user's dirs to the font path, as they might simply have been made
# read-only by the administrator, for whatever reason.

# Only do usr_fdir and usr_odir if they are *not* listed in fontpaths.
if [ -e $sys_odir/fonts.dir ]
then
  xset +fp "$sys_odir"
fi
test $do_usr_odir -eq 1 && test -d "$usr_odir" && (mkfontdir "$usr_odir" ; xset +fp "$usr_odir")
test $do_usr_fdir -eq 1 && test -d "$usr_fdir" && (mkfontdir "$usr_fdir" ; xset fp+ "$usr_fdir")
test -d "$sys_fdir" && xset fp+ "$sys_fdir"

# Ask X11 to rebuild its font list.
xset fp rehash

# Set a left cursor instead of the standard X11 "X" cursor, since I've heard
# from some users that they're confused and don't know what to do. This is
# especially necessary on slow machines, where starting TDE takes one or two
# minutes until anything appears on the screen.
#
# If the user has overwritten fonts, the cursor font may be different now
# so don't move this up.
#
xsetroot -cursor_name left_ptr

# Get Ghostscript to look into user's TDE fonts dir for additional Fontmap.
if test -n "$GS_LIB" ; then
  GS_LIB=$usr_fdir:$GS_LIB
  export GS_LIB
else
  GS_LIB=$usr_fdir
  export GS_LIB
fi

# Link "tmp" "socket" and "cache" resources to directory in $TMP.
# Creates:
# - a directory $TMP/tde-$USER and is linked from $TDEHOME/tmp-$HOSTNAME to it.
# - a directory $TMP/tdesocket-$USER and is linked from $TDEHOME/socket-$HOSTNAME to it.
# - a directory /var/tmp/tdecache-$USER and is linked from $TDEHOME/cache-$HOSTNAME to it.
# Note: temporary locations can be overridden through the TDETMP and TDEVARTMP
# environment variables.
for resource in tmp cache socket; do
  if ! lnusertemp $resource >/dev/null; then
    echo "[starttde] Call to lnusertemp failed (temporary directories full?). Check your installation." 1>&2
    xmessage -center -geometry 600x100 "Call to lnusertemp failed (temporary directories full?). Check your installation."
    exit 1
  fi
done

# In case of dcop sockets left by a previous session, cleanup.
$TDEDIR/bin/dcopserver_shutdown

echo "[starttde] Starting Trinity..." 1>&2

# Start tde_dbus_hardwarecontrol at background
if [ -x $TDEDIR/bin/tde_dbus_hardwarecontrol ]; then
 (
  TDE_DBUS=$(dbus-send --system --print-reply --dest=org.freedesktop.DBus \
             /org/freedesktop/DBus org.freedesktop.DBus.StartServiceByName \
             string:org.trinitydesktop.hardwarecontrol \
             uint32:0 | \
             sed -n "s| *uint32 \([0-9]*\).*|\1|p")
  case "$TDE_DBUS" in
    2)
        TDE_DBUS_STATE="running"
        ;;
    1)
        TDE_DBUS_STATE="started"
        ;;
    *)
        TDE_DBUS_STATE="not started"
        ;;
  esac
  echo "[starttde] Trinity hardware control dbus daemon $TDE_DBUS_STATE." 1>&2
 )&
fi

# Detect any running Xorg composition managers.
$TDEDIR/bin/kdetcompmgr

# Run KPersonalizer before the session if this is the first login.
if test "$kpersonalizerrc_general_firstlogin" = "true"; then
  if [ ! -x $TDEDIR/bin/kpersonalizer ]; then
    echo "[starttde] kpersonalizer not found! Please install in order to properly configure your user profile." 1>&2
  else
    # Start only dcopserver, don't start whole tdeinit (takes too long).
    echo "[starttde] Running kpersonalizer..." 1>&2
    $TDEDIR/bin/dcopserver
    $TDEDIR/bin/twin --lock &
    $TDEDIR/bin/kpersonalizer --before-session
    # Handle kpersonalizer restarts (language change).
    while test $? -eq 1; do
      $TDEDIR/bin/kpersonalizer --r --before-session
    done
    $TDEDIR/bin/dcopquit twin
    $TDEDIR/bin/dcopserver_shutdown --wait
  fi
fi

# Apply any user-specific display configuration settings
$TDEDIR/bin/tdeinit_displayconfig
EXIT_CODE="$?"

# Remove moodin cache if we have a new wallpaper installed, jriddell. Distro-specific.
if [ -d "$tdehome/share/apps/ksplash/cache/Moodin/kubuntu" ]; then
  if is_newer /usr/share/wallpapers/kubuntu-wallpaper.png \
              "$tdehome/share/apps/ksplash/cache/Moodin/kubuntu/"
  then
    rm -rf "$tdehome/share/apps/ksplash/cache/Moodin/kubuntu/"
  fi
fi
# The is_newer function will no longer be used, so we unset it
unset is_newer

if test -z "$dl"; then
  # The splashscreen and progress indicator.
  case "$ksplashrc_ksplash_theme" in
    None)
      ;; # Nothing.
    Simple)
      if test "$kpersonalizerrc_general_firstlogin" = "true"; then
        $TDEDIR/bin/ksplashsimple
      fi # Otherwise started earlier.
      ;;
    *)
      $TDEDIR/bin/ksplash --nodcop
      ;;
  esac
fi

# Mark that full TDE session is running (for example, Konqueror preloading works only
# with full TDE running). The TDE_FULL_SESSION property can be detected by
# any X client connected to the same X session, even if not launched
# directly from the TDE session but for example, using "ssh -X", tdesu. $TDE_FULL_SESSION
# however guarantees that the application is launched in the same environment
# like the TDE session and that for example, TDE utilities/libraries are available.
# The matching tests are:
#   For $TDE_FULL_SESSION:
#     if test -n "$TDE_FULL_SESSION"; then ... whatever
#   For TDE_FULL_SESSION property:
#     xprop -root | grep "^TDE_FULL_SESSION" >/dev/null 2>/dev/null
#     if test $? -eq 0; then ... whatever
#
# Additionally there is $TDE_SESSION_UID with the uid of the user
# running the TDE session. It should be rarely needed (for example,
# after sudo to prevent desktop-wide functionality in the new user's kded).
#
TDE_FULL_SESSION=true
export TDE_FULL_SESSION
xprop -root -f TDE_FULL_SESSION 8s -set TDE_FULL_SESSION true
echo "[starttde] TDE_FULL_SESSION: $TDE_FULL_SESSION" 1>&2
TDE_SESSION_UID=`id -u`
export TDE_SESSION_UID
echo "[starttde] TDE_SESSION_UID: $TDE_SESSION_UID" 1>&2

# We set LD_BIND_NOW to increase the efficiency of tdeinit.
# tdeinit unsets this variable before loading applications.
LD_BIND_NOW=true $TDEDIR/bin/start_tdeinit_wrapper --new-startup +kcminit_startup
if test $? -ne 0; then
  # Startup error
  echo "[starttde] Could not start tdeinit. Check your installation." 1>&2
  xmessage -center -geometry 500x100 "Could not start tdeinit. Check your installation."
fi
echo "[starttde] tdeinit started successfully." 1>&2

# Finally, give the session control to the session manager.
# See tdebase/ksmserver for the description of the rest of the startup sequence.
# When set, the TDEWM environment variable will be used as Trinity's
# window manager instead of twin.
# When TDEWM is not set, ksmserver will ensure twin is started.
# kwrapper is used to reduce startup time and memory usage.
# kwrapper does not return useful error codes such as the exit code of ksmserver.
# We only check for 255, which means the ksmserver process could not be
# started. Any problems thereafter, for example, ksmserver failing to initialize,
# will remain undetected.
# tdeinit_phase1 is still experimental.
$TDEDIR/bin/tdeinit_phase1
EXIT_CODE="$?"
# If tdeinit_phase1 should cause problems, here is the old way:
# test -n "$TDEWM" && TDEWM="--windowmanager $TDEWM"
# $TDEDIR/bin/kwrapper $TDEDIR/bin/ksmserver $TDEWM
# EXIT_CODE="$?"
if test $EXIT_CODE -eq 255; then
  # Startup error
  echo "[starttde] An error was detected while attempting to load the session manager. Please check your installation for problems." 1>&2
  xmessage -center -geometry 500x100 "An error was detected while attempting to load the session manager. Please check your installation for problems."
fi

# Wait if there's any crashhandler shown.
while $TDEDIR/bin/dcop | grep -q ^drkonqi- ; do
  sleep 5
done

echo "[starttde] Shutting down Trinity..." 1>&2

# Clean up.
$TDEDIR/bin/tdeinit_shutdown
$TDEDIR/bin/dcopserver_shutdown --wait
$TDEDIR/bin/artsshell -q terminate
# KDE4 support.
if [ -f /usr/bin/kdeinit4_shutdown ]; then
  /usr/bin/kde4 kdeinit4_shutdown 2>/dev/null
fi

echo "[starttde] Running Trinity shutdown scripts..." 1>&2

# Run scripts found in shutdown directories. Those locations are:
# * $TDEHOME/shutdown
# * $PREFIX/shutdown
# * $TDEDIRS/shutdown ($TDEDIRS, not $TDEDIR)
# Presumed is $TDEDIRS/bin exists. Create $TDEDIRS/bin even when
# only using the shutdown directory or this snippet will fail to find
# that shutdown directory.
for prefix in `echo "$exepath" | sed -n -e 's,/bin[^/]*/,/shutdown/,p'`; do
  for file in `ls "$prefix" 2> /dev/null | egrep -v '(~|\.bak)$'`; do
    if [ -x "${prefix}${file}" ]; then
      echo "[starttde] Running ${prefix}${file}." 1>&2
      sh ${prefix}${file}
    fi
  done
done

unset TDE_FULL_SESSION
xprop -root -remove TDE_FULL_SESSION
unset TDE_SESSION_UID

echo "[starttde] Trinity shutdown complete." 1>&2
